SystemOrganization addCategory: #'HedgeHacks-Spreadsheet'!

AlignmentMorph subclass: #SpreadSheet
	instanceVariableNames: 'numRows numColumns rows colWidth rowHeight top left selectedField texture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-Spreadsheet'!

!SpreadSheet methodsFor: 'initialization' stamp: 'das 3/4/2004 20:56'!
drawOn: aCanvas

	selectedField ifNotNil:[
		aCanvas frameRectangle: (selectedField bounds translateBy:(-2@0)) color: Color black.].

! !

!SpreadSheet methodsFor: 'initialization' stamp: 'ar 1/12/2006 18:43'!
highlightFields: fields
	| val tfield |
	tfield := OrderedCollection new.
	fields do:[ :field |
		val := [field text asNumber] on: Error do:[:ex| ex return: nil].
		val ifNotNil:[
			tfield add: (field bounds->val).
		].
	].
	texture ifNotNil:[texture future highlightFields: tfield].
! !

!SpreadSheet methodsFor: 'initialization' stamp: 'das 3/5/2004 03:56'!
initialize

	| rloc row cloc tm x y z |
	super initialize.
	self color: Color transparent.
	self layoutPolicy: nil.
	self hResizing: #rigid.
	self vResizing: #rigid.
	numRows := 27.
	numColumns := 16.
	colWidth := OrderedCollection new.
	rowHeight := OrderedCollection new.
	numColumns timesRepeat:[colWidth add:64].
	numRows timesRepeat:[rowHeight add:28].
	rows := OrderedCollection new.
	top := 0.
	left := 0.
	rloc := top.
	1 to: numRows do:[:r |
		row := OrderedCollection new.
		cloc := left.
		1 to: numColumns do:[:c|
			tm:=SpreadSheetField new initialize: self row: r column:c.
			row add: tm.
			tm extent: (colWidth at: c)@(rowHeight at:r).
			tm position: cloc@rloc.
			cloc := cloc + (colWidth at: c).
			(r = 1 or:[c = 1])ifTrue:[
				c = 1 ifTrue:[ 
					r = 1 ifTrue:[tm contents:''.] 
				ifFalse:[tm contents: '[',((r-1) asString),']'.]
				]
					ifFalse:[tm contents: ($A asInteger + c-2)asCharacter asString.].
			tm margins: 4@0;centered.
			tm fontName: #ComicBold size: 18; textColor: Color blue; backgroundColor: Color white.
			] ifFalse:[
			"compute the Sombrero function."
			x:=((c-(numColumns/2.0)) * 5.0/numColumns).
			y:=((r-(numRows/2.0))* 5.0/numRows).
			z := (((x*x)+(y*y)) cos) asString.
			z size > 6 ifTrue:[
				z := z copyFrom: 1 to:6.].
			tm contents: (z,'  ').
			].
			self addMorph: tm.
			].
		rows add: row.
		rloc := rloc + (rowHeight at: r).
	].
	self extent: cloc@rloc.
		! !

!SpreadSheet methodsFor: 'initialization' stamp: 'ar 1/12/2006 18:36'!
noteTForm: aTForm
	texture := aTForm send:[:tf| tf texture].
! !

!SpreadSheet methodsFor: 'initialization' stamp: 'ar 1/12/2006 18:31'!
selectAll

	| all |
	all := OrderedCollection new.
	rows do:[:r |
		r do:[:c | all add: c]].
	self highlightFields: all.
		! !

!SpreadSheet methodsFor: 'initialization' stamp: 'ar 1/12/2006 18:31'!
selectColumn: cnum

	| col |
	col := OrderedCollection new.
	rows do:[:r | col add: (r at: cnum)].
	self highlightFields: col.
! !

!SpreadSheet methodsFor: 'initialization' stamp: 'ar 1/12/2006 18:31'!
selectField: field

	selectedField := field.
	selectedField ifNotNil:[
		self invalidRect: (selectedField bounds translateBy:(-2@0)).
		self highlightFields: {field}.
	].! !

!SpreadSheet methodsFor: 'initialization' stamp: 'ar 1/12/2006 18:31'!
selectRow: rnum

	self highlightFields: (rows at:rnum).
! !

!SpreadSheet methodsFor: 'initialization' stamp: 'ar 1/12/2006 18:34'!
updateField: field

	selectedField ifNotNil:[
		self invalidRect: (selectedField bounds translateBy:(-2@0))].
	selectedField := nil.
! !

TTextureHackForm subclass: #TSpreadSheetTxtr
	instanceVariableNames: 'selection farray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-Spreadsheet'!

!TSpreadSheetTxtr methodsFor: 'as yet unclassified' stamp: 'ar 1/12/2006 18:38'!
extent: ext

	super extent: ext.
	self highlightFields: farray.! !

!TSpreadSheetTxtr methodsFor: 'as yet unclassified' stamp: 'bgf 3/20/2006 23:34'!
highlightFields: fa

	| ext2 pos cube mat scl fValue |
	fa ifNil:[^ self].
	farray := fa.
	scl := self extent asFloatPoint / targetExtent.
	ext2 := extent/2.0.
	selection ifNotNil:[
		self removeChild: selection.
		selection := nil.].
	selection := TGroup new.
	self addChild: selection.
	farray do:[ :field |
		field value ifNotNil:[
			pos := field key center*scl.
			cube := TCube new.
			fValue :=  field value * scl x *250.
			cube extent: ((field key extent*scl)@fValue).
			cube translation: ((pos x-ext2 x)@(ext2 y-(pos y))@(fValue/2.0)).
			selection addChild: cube.
			mat := TMaterial new.
			fValue >0.0 ifTrue:[ mat color:  #(0.2 0.9 0.2 0.5) asFloatArray.]
			ifFalse:[ 
				fValue<0.0 ifTrue:[mat color:#(0.9 0.2 0.2 0.5)asFloatArray.] ifFalse:
			[mat color:#(0.2 0.2 0.9 0.5)asFloatArray.]].
			cube material: mat.
			cube solid: false.
		].

	].! !

!TSpreadSheetTxtr methodsFor: 'as yet unclassified' stamp: 'ar 1/12/2006 17:59'!
renderAlpha: ogl

	ogl glDisable: GLCullFace.
	super renderAlpha: ogl.
	ogl setCull.! !

TextMorph subclass: #SpreadSheetField
	instanceVariableNames: 'spreadSheet row column'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-Spreadsheet'!

!SpreadSheetField methodsFor: 'initialization' stamp: 'das 3/4/2004 20:13'!
acceptContents

	spreadSheet updateField: self.! !

!SpreadSheetField methodsFor: 'initialization' stamp: 'das 3/4/2004 23:36'!
initialize: ss

	spreadSheet := ss.
	self crAction: (MessageSend receiver: self selector: #acceptContents).
	self autoFit: false.! !

!SpreadSheetField methodsFor: 'initialization' stamp: 'das 3/5/2004 01:52'!
initialize: ss row:r column:c

	spreadSheet := ss.
	self crAction: (MessageSend receiver: self selector: #acceptContents).
	self autoFit: false.
	row := r.
	column := c.! !

!SpreadSheetField methodsFor: 'initialization' stamp: 'das 3/5/2004 02:47'!
mouseDown: evt

	super mouseDown: evt.
	(row=1 and:[column=1])ifTrue:[^spreadSheet selectAll].
	row=1 ifTrue:[^spreadSheet selectColumn:column].
	column=1 ifTrue:[^spreadSheet selectRow:row].
	spreadSheet selectField: self.
! !

!SpreadSheetField methodsFor: 'initialization' stamp: 'das 3/4/2004 20:38'!
releaseEditor

	super releaseEditor.
	self acceptContents.! !
